# SNAP Generate QRIS

This API is used to Generate QRIS in SNAP standard for route payment.

<table data-header-hidden><thead><tr><th width="131"></th><th></th></tr></thead><tbody><tr><td><strong>URL Path</strong></td><td><a href="https://debit-sandbox.faspay.co.id/v1.0/qr/qr-mpm-generate">https://debit-sandbox.faspay.co.id/v1.0/qr/qr-mpm-generate</a></td></tr><tr><td><strong>Method</strong></td><td>POST</td></tr></tbody></table>

## Request Parameter

The parameters that must be provided by the Merchant system to be accessed by the Faspay system are as follows:

<table><thead><tr><th width="246">SNAP Parameter</th><th width="170">Data Type</th><th width="86">M/O/C</th><th>Description</th></tr></thead><tbody><tr><td>partnerReferenceNo</td><td>String(32)</td><td>M</td><td>Transaction identifier on service consumer system</td></tr><tr><td>amount</td><td>Object</td><td>M</td><td> An object that contains information about an amount or value within a specific context.</td></tr><tr><td>    value</td><td>String(16,2)</td><td>M</td><td>Net amount of the transaction. If it's IDR then value includes 2 decimal digits. e.g. IDR 10.000,- will be placed with 10000.00 with 2 decimal</td></tr><tr><td>    currency</td><td>String(3)</td><td>M</td><td>Currency (ISO4217)</td></tr><tr><td>merchantId</td><td>String(5)</td><td>M</td><td>Merchant identifier that is unique per each merchant</td></tr><tr><td>validityPeriod</td><td>String(25)</td><td>M</td><td>The time when the QRIS validis valid. ISO-8601</td></tr><tr><td>additionalInfo</td><td>Object</td><td>O</td><td>Additional information</td></tr><tr><td>    billDate</td><td>String (25)</td><td>M</td><td><p>Transaction/ Order Date.</p><p>ISO-8601</p></td></tr><tr><td>    billDescription</td><td>String (128)</td><td>M</td><td>Bill description</td></tr><tr><td>    channelCode</td><td>String (32)</td><td>M</td><td><p>Payment Channel Code</p><p> </p><p><strong>List Channel Code:</strong></p><p>715 Linkaja QRIS</p><p>711 ShopeePay QRIS</p></td></tr><tr><td>    phoneNo</td><td>String (30)</td><td>C</td><td><p>Customer Phone Number</p><p> </p><p><strong>Notes:</strong></p><p>Mandatory for payment channel OVO Tokenized</p></td></tr><tr><td>   route</td><td>Object</td><td> </td><td> </td></tr><tr><td>        owner</td><td>Alphanumeric (32) </td><td> </td><td><p>Registered partner id that owns/generates the transaction. </p><p> </p><p><strong>Notes:</strong></p><ul><li>1 transaction only can contain 1 owner. </li><li>If null, then the remaining transaction amount will belong to the merchant’s Sendme balance. </li></ul></td></tr><tr><td>       partnerId</td><td>Alphanumeric (32) </td><td> </td><td>Merchant partner id number.</td></tr><tr><td>       partnerAmount</td><td>Numeric (15) </td><td> </td><td>Disbursement amount to partner.  </td></tr></tbody></table>

### Sample Request

{% tabs %}
{% tab title="Sample Request" %}

```json
{
    "partnerReferenceNo": "2020102900000000000001",
    "amount": {
        "value": "10000.00",
        "currency": "IDR"
    },
    "merchantId": "99999",
    "validityPeriod": "2024-09-19T12:08:56+07:00",
    "additionalInfo": {
        "billDate": "2024-09-18T10:08:56+07:00",
        "billDescription": "Payment #12345678",
        "channelCode": "711",
        "phoneNo": "089876543210",
        "route":[
        {
            "owner": "26100253"
        },
        {
            "partnerId": "29195827",
            "partnerAmount": "4000.00"
        },
        {
            "partnerId": "andre-121321346",
            "partnerAmount": "5000.00"
        }
    ]
    }
}

```

{% endtab %}
{% endtabs %}

## Response Parameter

Response parameters are parameters that will be delivered by Faspay system in response to the request that have been sent by the merchant system. If no parameters appropriate/value are incorrect, the transaction will be rejected in the system Faspay.

<table><thead><tr><th width="284">SNAP Parameter</th><th width="142">Data Type</th><th width="96">M/O/C</th><th>Description</th></tr></thead><tbody><tr><td>responseCode</td><td>String (7)</td><td>M</td><td>Response code. In details <a href="/pages/rtKHzHoYL4gBW3Z4iWQr">here</a></td></tr><tr><td>responseMessage</td><td>String (150)</td><td>M</td><td>Response description. In details <a href="/pages/rtKHzHoYL4gBW3Z4iWQr">here</a></td></tr><tr><td>referenceNo</td><td>String (16)</td><td>M</td><td>Transaction identifier on service provider system. Must be filled upon successful transaction</td></tr><tr><td>partnerReferenceNo</td><td>String (32)</td><td>M</td><td>Transaction identifier on service consumer system</td></tr><tr><td>qrContent</td><td>String (512)</td><td>C</td><td>QR String MPM. Will be returned only for direct merchant. boi_oky=direct.</td></tr><tr><td>qrUrl</td><td>String (256)</td><td>C</td><td><p>QR URL for</p><p>download QR</p><p>Image</p><p> </p><p>Will be returned</p><p>only for direct</p><p>merchant.</p><p>boi_oky=direct.</p></td></tr><tr><td>additionalInfo</td><td>Object</td><td>O</td><td>Additional information</td></tr><tr><td>    qrImageUrl</td><td>String (256)</td><td>M</td><td><p>Redirect URL to display QR Image</p><p>in Faspay page</p><p> </p><p>Will not be returned for direct merchant. boi_oky=direct.</p></td></tr><tr><td>    merchantId</td><td>String (5)</td><td>M</td><td>Merchant identifier that is unique per each merchant</td></tr><tr><td>    nmid</td><td>String (15)</td><td>M</td><td>National Merchant Identification</td></tr><tr><td>    amount</td><td>Object</td><td>M</td><td>An object that contains information about an amount or value within a specific context.</td></tr><tr><td>         value</td><td>String (16,2)</td><td>M</td><td>Net amount of the transaction. If it's IDR then value includes 2 decimal digits. e.g. IDR 10.000,- will be placed with 10000.00 with 2 decimal</td></tr><tr><td>        currency</td><td>String (3)</td><td>M</td><td>Currency (ISO4217)</td></tr><tr><td>   phoneNo</td><td>String (30)</td><td>C</td><td><p>Customer Phone Number</p><p></p><p><strong>Notes:</strong></p><p>Mandatory for payment channel OVO Tokenized</p></td></tr><tr><td>   route</td><td>Object</td><td>O</td><td> </td></tr><tr><td>      owner</td><td>Alphanumeric (32) </td><td>O</td><td><p>Registered partner id that owns/generates the transaction. </p><p> </p><p><strong>Notes:</strong></p><ul><li> 1 transaction only can contain 1 owner. </li><li>If null, then the remaining transaction amount will belong to the merchant’s Sendme balance. </li></ul></td></tr><tr><td>      partnerId</td><td>Alphanumeric (32) </td><td>O</td><td>Merchant partner id number.</td></tr><tr><td>      partnerAmount</td><td>Numeric (15) </td><td>C</td><td>Disbursement amount to partner.  </td></tr></tbody></table>

### Sample Response

{% tabs %}
{% tab title="Response Sample" %}

```json
{
    "responseCode": "2004700",
    "responseMessage": "Request has been processed successfully",
    "referenceNo": "1999971121447888",
    "partnerReferenceNo": "2020102900000000000001",
    "qrContent": "00020101021226560016ID.CO.SHOPEE.WWW011893600918000000026602032660303UBE520412345303360540810000.005802ID5912Faspay Store6015KOTA JAKARTA SE610512345622805241999971121447888-145290163043A7C",
    "qrUrl": "https://debit-sandbox.faspay.co.id/__assets/qr/99999-1999971121447888.png",
    "additionalInfo": {
        "qrImageUrl": "https://debit-sandbox.faspay.co.id/pws/100003/0830000010100000/a32c3d417ec84d6e977484ab02192d26fd58563a?trx_id=1999971121447888&merchant_id=99999&bill_no=2020102900000000000001",
        "merchantId": "99999",
        "nmid": "ID2022149621171",
        "amount": {
            "value": "10000.00",
            "currency": "IDR"
        },
        "phoneNo": "089876543210",
        "route": [
            {
                "owner": "26100253"
            },
            {
                "partnerId": "29195827",
                "partnerAmount": "4000.00"
            },
            {
                "partnerId": "andre-121321346",
                "partnerAmount": "5000.00"
            }
        ]
    }
}

```

{% endtab %}
{% endtabs %}


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.faspay.co.id/merchant-integration/api-reference-1/route-payment/snap-generate-qris.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
